<?php
	$ext = '.png';
	$fonts = array('./arialbd.ttf', './arialbd.ttf', './arialbd.ttf', './arialbd.ttf', './arialbd.ttf', './arialbd.ttf', './arialbd.ttf');
	$quality = '100';

  $cachefile = "./cache/server_".$_SERVER['QUERY_STRING'].$ext;
  $cachefile = str_replace(':', '-', $cachefile);

  $cachetime = 15;	//czas cache'owania

  if (file_exists($cachefile) && (time() - $cachetime < filemtime($cachefile))) 
  {
	send_headers();
	echo file_get_contents($cachefile);
	exit;
  }
  ob_start();

	define("CLASS_PQ_PHP", 1);
	include_once("./SNS/class_PQ.php");
	include_once("./SNS/PQ/PQ_PARENT.php");
	include_once("./SNS/PQ/halflife.php");

	if (strpos($_GET['ip'], ':'))
	{
		$ipp = explode(":", $_GET['ip']);

		if (count($ipp)==2)
		{
			$conf_ip = $ipp[0];
			$conf_port = $ipp[1];
		}
	}
	else
	{
	$conf_ip = ($_GET['ip'])?$_GET['ip']:'91.203.133.202';
	$conf_port = ($_GET['port'])?$_GET['port']:'27208';
	$nazwa = ($_GET['nazwa'])?$_GET['nazwa']:'CS-Rules.pl #1 [4FUN+BF2]';
	}

	if (strlen($conf_port)>5)
		$conf_port = substr($conf_port, 0, 5);
	
	$conf = array(
		'ip'		=> $conf_ip,
		'port'	=> $conf_port,
		'querytype'	=> 'halflife',
		'master'	=> 0,
		'timeout'	=> 3,
		'retries'	=> 1,
	);

	$pq = PQ::create($conf);
	$info = $pq->query_info($conf['ip'].':'.$conf['port']);

  $w = 350;	//szerokosc
  $h = 44;	//wysokosc
  if ($info==NULL)
        {
               $base = 'offline';
                if($ext == '.jpg') {
                        $input = imagecreatefromjpeg($base . $ext);
                } else if($ext == '.png') {
                        $input = imagecreatefrompng($base . $ext);
                        imageAlphaBlending($input, true);
                        imageSaveAlpha($input, true);
                }
        } else {
			$base = 'baner';
                /*tlo gdy serwer online*/
                if($ext == '.jpg') {
                        $input = imagecreatefromjpeg($base . $ext);
                } else if($ext == '.png') {
                        $input = imagecreatefrompng($base . $ext);
                        imageAlphaBlending($input, true);
                        imageSaveAlpha($input, true);
                }
        }

	if (true)
	{
		if($ext == '.jpg') {
			$input = imagecreatefromjpeg($base . $ext);
		} else if($ext == '.png') {
			$input = imagecreatefrompng($base . $ext);
			imageAlphaBlending($input, true);
			imageSaveAlpha($input, true);
		}
	} else {
		$input = imagecreatetruecolor($w, $h);
		imagefilledrectangle($input, 1, 1, $w-2, $h-2, imagecolorallocate($input, 128, 128, 128));
	}

	//Kolory czcionek
	$white = imagecolorallocate($input, 255, 255, 255);
	$grey = imagecolorallocate($input, 128, 128, 128);
	$black = imagecolorallocate($input, 0, 0, 0);
	$blue = imagecolorallocate($input, 0, 0, 255);
	$green = imagecolorallocate($input, 0, 255, 0);
	$red = imagecolorallocate($input, 255, 0, 0);
	$pink = imagecolorallocate($input, 255, 105, 180);
	$yellow = imagecolorallocate($input, 255, 255, 0);
	$szary = imagecolorallocate($input, 59, 57, 58);

	if ($info==NULL)
	{

		imagettftext($input,
								 7,			//wielkosc czcionki
								 0,			//angle
								 37,			//x
								 25,			//y
								 $szary,		//kolor czcionki
								 $fonts[4],		//czcionka
								 $nazwa);
	}
	else
	{
	
		imagettftext($input,
								 8,			//wielkosc czcionki
								 0,			//angle
								 37,			//x
								 26,			//y
								 $szary,		//kolor czcionki
								 $fonts[5],		//czcionka
								 $nazwa);		//nazwa serwera
								 
		$ipport = htmlspecialchars(strtoupper($info['ip'].':'.$info['port']));
		
		imagettftext($input,
								 10,			//wielkosc czcionki
								 0,			//angle
								 37,			//x
								 26,			//y
								 $white,		//kolor czcionki
								 $fonts[2],		//czcionka
								 $ipport);		//IP:PORT

		$size = imagettfbbox(9, 0, $fonts[0], $ipport);
		$width = 45 + abs($size[2] - $size[0]);

		$pltn = htmlspecialchars(strtoupper($info['totalplayers'].'/'.$info['maxplayers']));
		
		imagettftext($input,
								 7,			//wielkosc czcionki
								 0,			//angle
								 301,			//x
								 26,			//y
								 $white,		//kolor czcionki
								 $fonts[6],		//czcionka
								 $pltn);		//ilosc graczy/sloty

		$size2 = imagettfbbox(9, 0, $fonts[0], $pltn);
		$width2 = $width + 10 + abs($size2[2] - $size2[0]);

		imagettftext($input,
								 4.7,			//wielkosc czcionki
								 0,			//angle
								 160,			//x
								 26,			//y
								 $black,		//kolor czcionki
								 $fonts[6],		//czcionka
								 htmlspecialchars($info['map']));	//mapa


	}

	if($ext == '.jpg') {
		imagejpeg($input, NULL, $quality);
	} else if($ext == '.png') {
		imagepng($input, NULL, ($quality / 10) - 1);
	}

	function send_headers() {
		global $config;
		if($ext == '.png') {
			header ('Content-type: image/png');
		} else {
			header ('Content-type: image/jpeg');
		}
	}

  $fp = fopen($cachefile, 'wb');
  fwrite($fp, ob_get_contents());
  fclose($fp);
  send_headers();
  ob_end_flush(); 
?>